Safari 4 cannot be used to update firmware on Linksys routers.